/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of XS.xs. Do not edit this file, edit XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "XS.xs"
/*-
 * Copyright (c) 2011 cPanel, Inc.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the same terms as Perl itself, either Perl version 5.10.1 or,
 * at your option, any later version of Perl 5 you may have available.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "md5crypt.h"
#include "des.h"
#include "sha256crypt.h"
#include "sha512crypt.h"


typedef char *(*crypt_function_t)(const char*, const char*);

/* The enum and map are in the same order for easy lookup */
typedef enum { MD5 = 0, APR1, DES, SHA256, SHA512 } crypt_scheme_t;

crypt_function_t crypt_function_map[] = {
    cpx_crypt_md5,
    cpx_crypt_apr1,
    cpx_crypt_des,
    cpx_sha256_crypt,
    cpx_sha512_crypt
};

/* This function performs all cleanup of input and calls the correct C crypt function */
SV* _multi_crypt(crypt_scheme_t scheme, SV *pw, SV *salt) {
    char *cryptpw_cstr = NULL;
    char *pw_cstr = NULL;
    char *salt_cstr = NULL;
    SV* RETVAL = &PL_sv_undef;
    if (SvPOK(pw)) {
        pw_cstr = SvPVX(pw);
    } else {
        pw_cstr = "";
    }
    if (SvPOK(salt)) {
        salt_cstr = SvPVX(salt);
    } else {
        salt_cstr = "";
    }
    cryptpw_cstr = crypt_function_map[scheme]( pw_cstr, salt_cstr );
    if (cryptpw_cstr != NULL) {
        RETVAL = newSVpv(cryptpw_cstr,0);
    }
    return RETVAL;
}

#line 66 "XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 210 "XS.c"

XS_EUPXS(XS_Crypt__Passwd__XS_unix_md5_crypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Passwd__XS_unix_md5_crypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pw, salt");
    {
	SV *	pw = ST(0)
;
	SV *	salt = ST(1)
;
	SV *	RETVAL;
#line 66 "XS.xs"
        RETVAL = _multi_crypt(MD5, pw, salt);

#line 227 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Passwd__XS_apache_md5_crypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Passwd__XS_apache_md5_crypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pw, salt");
    {
	SV *	pw = ST(0)
;
	SV *	salt = ST(1)
;
	SV *	RETVAL;
#line 77 "XS.xs"
        RETVAL = _multi_crypt(APR1, pw, salt);

#line 250 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Passwd__XS_unix_des_crypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Passwd__XS_unix_des_crypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pw, salt");
    {
	SV *	pw = ST(0)
;
	SV *	salt = ST(1)
;
	SV *	RETVAL;
#line 88 "XS.xs"
        RETVAL = _multi_crypt(DES, pw, salt);

#line 273 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Passwd__XS_unix_sha256_crypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Passwd__XS_unix_sha256_crypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pw, salt");
    {
	SV *	pw = ST(0)
;
	SV *	salt = ST(1)
;
	SV *	RETVAL;
#line 99 "XS.xs"
        RETVAL = _multi_crypt(SHA256, pw, salt);

#line 296 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Passwd__XS_unix_sha512_crypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Passwd__XS_unix_sha512_crypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pw, salt");
    {
	SV *	pw = ST(0)
;
	SV *	salt = ST(1)
;
	SV *	RETVAL;
#line 110 "XS.xs"
        RETVAL = _multi_crypt(SHA512, pw, salt);

#line 319 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Crypt__Passwd__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Crypt__Passwd__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Crypt::Passwd::XS::unix_md5_crypt", XS_Crypt__Passwd__XS_unix_md5_crypt, file, "$$");
        (void)newXSproto_portable("Crypt::Passwd::XS::apache_md5_crypt", XS_Crypt__Passwd__XS_apache_md5_crypt, file, "$$");
        (void)newXSproto_portable("Crypt::Passwd::XS::unix_des_crypt", XS_Crypt__Passwd__XS_unix_des_crypt, file, "$$");
        (void)newXSproto_portable("Crypt::Passwd::XS::unix_sha256_crypt", XS_Crypt__Passwd__XS_unix_sha256_crypt, file, "$$");
        (void)newXSproto_portable("Crypt::Passwd::XS::unix_sha512_crypt", XS_Crypt__Passwd__XS_unix_sha512_crypt, file, "$$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

